require 'App42Response.rb'

module App42
  module AppTab
    #
    # This Bill object is the value object which contains the properties of Bill
    # along with the setter & getter for those properties.
    #
    class Bill < App42Response
      attr_accessor :userName, :transactionId, :usageName, :month, :totalUsage, :totalCost, :currency, :licenseTransaction, :storageTransaction, :levelTransaction, :featureTransaction, :bandwidthTransaction, :timeTransaction

      @userName
      @usageName
      @month
      @totalUsage
      @totalCost
      @currency
      @transactionId
      @licenseTransaction
      @storageTransaction
      @levelTransaction
      @featureTransaction
      @bandwidthTransaction
      @timeTransaction
    end

    class LicenseTransaction
      attr_accessor :cost, :currency, :transactionList, :totalUsage, :totalCost, :transactionList

      @cost
      @currency
      @transactionList = Array.new()
      @totalUsage
      @totalCost
    end

    class TransactionLic
      attr_accessor :serviceName, :transactionId, :issueDate, :valid, :key

      @serviceName
      @transactionId
      @issueDate
      @valid
      @key
      #
      # This is a constructor that takes no parameter
      #
      def initialize(lic)
        lic.transactionList.push(self)
      end
    end

    class StorageTransaction
      attr_accessor :cost, :currency, :unit, :space, :totalUsage, :totalCost, :transactionList

      @cost
      @currency
      @unit
      @space
      @totalUsage
      @totalCost
      @transactionList = Array.new()
    end

    class TransactionStor
      attr_accessor :serviceName, :transactionId, :usage, :usageDate

      @serviceName
      @transactionId
      @usageDate
      @usage
      #
      # This is a constructor that takes no parameter
      #
      def initialize(stor)
        stor.transactionList.push(self)
      end
    end

    class LevelTransaction
      attr_accessor :cost, :currency, :transactionList, :totalUsage, :totalCost
      @cost
      @currency
      @transactionList = Array.new()
      @totalUsage
      @totalCost
    end

    class TransactionLev
      attr_accessor :serviceName, :transactionId, :usageDate

      @serviceName
      @transactionId
      @usageDate
      #
      # This is a constructor that takes no parameter
      #
      def initialize(lev)
        lev.transactionList.push(self)
      end
    end

    class FeatureTransaction
      attr_accessor :cost, :currency, :transactionList, :totalUsage, :totalCost

      @cost
      @currency
      @transactionList = Array.new()
      @totalUsage
      @totalCost
    end

    class TransactionFeat
      attr_accessor :serviceName, :transactionId, :usageDate

      @serviceName
      @transactionId
      @usageDate
      #
      # This is a constructor that takes no parameter
      #
      def initialize(feat)
        feat.transactionList.push(self)
      end
    end

    class BandwidthTransaction
      attr_accessor :cost, :currency, :unit, :bandwidth, :totalUsage, :totalCost, :transactionList
      @cost
      @currency
      @unit
      @bandwidth
      @totalUsage
      @totalCost
      @transactionList
    end

    class TransactionBand
      attr_accessor :serviceName, :transactionId, :usageDate, :usage

      @serviceName
      @transactionId
      @usageDate
      @usage
      #
      # This is a constructor that takes no parameter
      #
      def initialize(band)
        band.transactionList.push(self)
      end
    end

    class TimeTransaction
      attr_accessor :cost, :currency, :unit, :time, :totalUsage, :totalCost, :transactionList

      @cost
      @currency
      @unit
      @time
      @totalUsage
      @totalCost
      @transactionList = Array.new()
    end

    class TransactionTim
      attr_accessor :serviceName, :transactionId, :usageDate, :usage

      @serviceName
      @transactionId
      @usageDate
      @usage
      #
      # This is a constructor that takes no parameter
      #
      def initialize(tim)
        tim.transactionList.push(self)
      end
    end

  end
end

