# -----------------------------------------------------------------------
#  Copyright © 2012 ShepHertz Technologies Pvt Ltd. All rights reserved.
# -----------------------------------------------------------------------

require 'json/pure'
require 'App42ResponseBuilder.rb'
require 'social/Social.rb'

module App42
  module Social

    #
    #
    # SocialResponseBuilder class converts the JSON response retrieved from the
    # server to the value object i.e Social
    #
    #
    class SocialResponseBuilder < App42ResponseBuilder

      #
      # Converts the response in JSON format to the value object i.e Social
      #
      # @param json
      #      - response in JSON format
      #
      # @return Social object filled with json data
      #
      def buildResponse(json)
        fbJSONObject = getServiceJSONObject("social", json)
        social = Social.new
        buildObjectFromJSONTree(social, fbJSONObject);
        social.strResponse=json
        social.isResponseSuccess = isResponseSuccess(json)
        return social
      end
    end
  end
end